#include "drzewo.h"


Tree::Tree()
{
	root = NULL;
//	cout << "Jestem konstruktorem klasy Tree" << endl;
}

/* Dodawanie slowa do drzewa */
void Tree::Add(string word)
{
	root = Add(root,word);
}

/* Wyswietlanie zawartosci drzewa */
void Tree::Print()
{
	Print(root);
}

/* Dodaje 'word' do drzewa (galezi) wskazanego przez 'k' umieszczajac je
  w porzadku alfabetycznym. Wartoscia zwracana jest adres drzewa (wezla) 
  po ktualizacji  jego zawartosci.   */
Node *Tree::Add(Node *k,string word)
{
	if(!k)
	{
		Node *w = new Node(word); 
		return w;
	}

	if(k->word == word)
	{
		k->count++;
		return k;	
	}

	if(k->word > word) k->left=Add(k->left,word);
	else k->right=Add(k->right,word);

	return k;
}

/* Wyswietla zawartosc drzewa (galezi) poczynajac od najbardziej skrajnego 
 *  lewego wezla do najdalszego wezla na prawo. Wyswietlana jest lista slow w porzadku 
 *  alfabetycznym i count  wystapien slow w drzewie. */
void Tree::Print(Node *k)
{
	if(!k) return ;
	Print(k->left);
	k->Print();
	Print(k->right);
}


Tree::~Tree()
{
	Free(root);
	root=NULL;
}

/* Usuwa z pamieci strukture drzewa. */
void Tree::Free(Node *d)
{
	if(d)
   {
      Free(d->left);
	  d->left = NULL;

      Free(d->right);
	  d->right = NULL;

	  delete d;
   }

}
